;(load "d:\\program_12_fejezet.lsp")

;Kicserli a listban a megadott index elemet
(defun csere (list n elem)
  (cond
    ((null list) ())
    ((= n 0) (cons elem (cdr list)))
    (t (cons (car list) (csere (cdr list) (- n 1) elem)))))

;Elfogba egy lista megadott index elemt
(defun eldob (list n)
  (cond
    ((null list) ())
    ((= n 0) (cdr list))
    (t (cons (car list) (eldob (cdr list) (- n 1))))))
	
;Beolvassa a fajlt a megadott helyrol
(defun falbeolvas (path)
  (with-open-file (s path)
    (loop with eof = (list nil)
          for form = (read s nil eof)
          until (eq form eof)
          collect form into forms
          counting t into form-count
          finally (return (values forms form-count)))))
		  
;kivg a lista elejtl n elemet
(defun kivag (lis n)
	(cond 
		((null lis) ())
		((> n 0) (cons (car lis) (kivag (cdr lis) (- n 1))))
		((= n 0) ())
	))
	
;kivg a listbl az n, indextl c darab elemet
(defun reszlista (lis n c)
	(cond
		((null lis) ())
		((= n 0) (kivag lis c))
		(t (reszlista (cdr lis) (- n 1) c))		
	))
	
;Kirja a megadott listt fjlba
(defun fajlkiir (path lista)
;(with-open-file (outfile "d:\\proba2" :direction :output)
(with-open-file (outfile path :direction :output)
	(loop for i from 1 to (list-length lista) do (
		pprint (nth (- i 1) lista) outfile
	))))

	
	
;----FGGVNYEK MEGHVSA:--------------------------------
;----Beolvasom a fjl tartamt egy listba----------------
(setq lista (falbeolvas "d:\\lispinput_program_12_fejezet"))
;----Ha a fjl els kt eleme mondja meg a 
;----mondat kezdindext s hosszt: ---------------------
(setq honnan (nth 0 lista))
(setq mennyit (nth 1 lista))
;----Kiszedem a mondat listba a mondatot jell rszlistkat
(setq mondat (reszlista lista honnan mennyit))
;----Kirjuk a mondatot egy fjlba------------------------
(fajlkiir "d:\\lispoutput1" mondat)
;----Meghvhat fggvnyek: ------------------------------
;lista
;(csere lista 2 'kiskutya)
;(setq lista (eldob lista 4))
;(reszlista lista 4 2)